diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index 99d480c31a1b2c565055f24940c2b15355a79b31..eb124ebb0251f02bedfcc317825451aa6cfc66af 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -39,9 +39,9 @@ PKI_CORE_VERSION="10.1.0"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_CORE}.spec"
-PKI_COMPONENT_LIST="test setup symkey util common native-tools java-tools server selinux ca kra ocsp tks silent"
+PKI_COMPONENT_LIST="test setup symkey util common native-tools java-tools server selinux ca kra ocsp tks tps-tomcat silent"
 
-if [ "$JAVADOC" = "" ]; then
+if [ "$WITHOUT_JAVADOC" = "" ]; then
     PKI_COMPONENT_LIST="$PKI_COMPONENT_LIST javadoc"
 fi
 
@@ -50,7 +50,7 @@ fi
 ##
 
 if [ $WORK_DIR ]; then
-    PKI_PACKAGES="$WORK_DIR"
+    PKI_PACKAGES="`cd $WORK_DIR ; pwd`"
 else
     PKI_PACKAGES="${PKI_PWD}/packages"
 fi
@@ -154,12 +154,25 @@ else
 	cd ${PKI_BASE_DIR}
 	cp -p ${PKI_BASE_MANIFEST} ${PKI_CORE_BASE_DIR}
 	cp -p VERSION ${PKI_CORE_BASE_DIR}
-	for component in "${PKI_COMPONENT_LIST}" ;
+	for component in ${PKI_COMPONENT_LIST} ;
 	do
-		find ${component}             \
+		if [ "${component}" = "tps-tomcat" ] ; then
+			# rename tps-tomcat to tps
+			dest="tps"
+		else
+			dest="${component}"
+		fi
+
+		# copying ${PKI_BASE_DIR}/${component} to ${PKI_CORE_BASE_DIR}/${dest}
+		cd ${component}
+		mkdir ${PKI_CORE_BASE_DIR}/${dest}
+
+		find                          \
 		-name .svn -prune -o          \
 		-name *.swp -prune -o         \
-		-print | cpio -pdum ${PKI_CORE_BASE_DIR} > /dev/null 2>&1
+		-print | cpio -pdum ${PKI_CORE_BASE_DIR}/${dest} > /dev/null 2>&1
+
+		cd ..
 	done
 	cd - > /dev/null 2>&1
 
diff --git a/scripts/compose_pki_migrate_packages b/scripts/compose_pki_migrate_packages
index f9bcaccb8292d029ffb2689dfc30cfa110168ec8..be93c42c1d45aab24495d617871d4b20540855fb 100755
--- a/scripts/compose_pki_migrate_packages
+++ b/scripts/compose_pki_migrate_packages
@@ -47,7 +47,7 @@ PKI_COMPONENT_LIST="test migrate"
 ##
 
 if [ $WORK_DIR ]; then
-    PKI_PACKAGES="$WORK_DIR"
+    PKI_PACKAGES="`cd $WORK_DIR ; pwd`"
 else
     PKI_PACKAGES="${PKI_PWD}/packages"
 fi
diff --git a/scripts/compose_pki_ra_packages b/scripts/compose_pki_ra_packages
index 0e93ee4e1688d8820af15d767134f8021550a114..9aa4dda141d570c2d8677cb417550178da03e006 100755
--- a/scripts/compose_pki_ra_packages
+++ b/scripts/compose_pki_ra_packages
@@ -47,7 +47,7 @@ PKI_COMPONENT_LIST="ra"
 ##
 
 if [ $WORK_DIR ]; then
-    PKI_PACKAGES="$WORK_DIR"
+    PKI_PACKAGES="`cd $WORK_DIR ; pwd`"
 else
     PKI_PACKAGES="${PKI_PWD}/packages"
 fi
diff --git a/scripts/compose_pki_tps_packages b/scripts/compose_pki_tps_packages
index a23c52982472ede6494326404b303675f5fa1a12..4ffa83cf50f61b97bc2d5cdb315b5c5828a86cbc 100755
--- a/scripts/compose_pki_tps_packages
+++ b/scripts/compose_pki_tps_packages
@@ -47,7 +47,7 @@ PKI_COMPONENT_LIST="tps"
 ##
 
 if [ $WORK_DIR ]; then
-    PKI_PACKAGES="$WORK_DIR"
+    PKI_PACKAGES="`cd $WORK_DIR ; pwd`"
 else
     PKI_PACKAGES="${PKI_PWD}/packages"
 fi
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 2efa3917302a27dd3a6940d308637d4c21801004..55cb03231572feb08181e9472293c181f0383fc2 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -5,7 +5,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.1.0
-Release:          0.9%{?dist}
+Release:          0.10%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -107,6 +107,7 @@ PKI Core contains ALL top-level java-based Tomcat PKI components:      \
   * pki-kra                                                            \
   * pki-ocsp                                                           \
   * pki-tks                                                            \
+  * pki-tps-tomcat                                                     \
   * pki-javadoc                                                        \
                                                                        \
 which comprise the following corresponding PKI subsystems:             \
@@ -115,6 +116,7 @@ which comprise the following corresponding PKI subsystems:             \
   * Data Recovery Manager (DRM)                                        \
   * Online Certificate Status Protocol (OCSP) Manager                  \
   * Token Key Service (TKS)                                            \
+  * Token Processing Service (TPS)                                     \
                                                                        \
 For deployment purposes, PKI Core contains fundamental packages        \
 required by BOTH native-based Apache AND java-based Tomcat             \
@@ -313,8 +315,9 @@ The PKI Server Framework is required by the following four PKI subsystems:
 
     the Certificate Authority (CA),
     the Data Recovery Manager (DRM),
-    the Online Certificate Status Protocol (OCSP) Manager, and
-    the Token Key Service (TKS).
+    the Online Certificate Status Protocol (OCSP) Manager,
+    the Token Key Service (TKS), and
+    the Token Processing Service (TPS).
 
 This package is a part of the PKI Core used by the Certificate System.
 The package contains scripts to create and remove PKI subsystems.
@@ -476,6 +479,37 @@ provided by the PKI Core used by the Certificate System.
 %{overview}
 
 
+%package -n       pki-tps-tomcat
+Summary:          Certificate System - Token Processing Service
+Group:            System Environment/Daemons
+
+BuildArch:        noarch
+
+Requires:         java >= 1:1.7.0
+Requires:         pki-server = %{version}-%{release}
+Requires(post):   systemd-units
+Requires(preun):  systemd-units
+Requires(postun): systemd-units
+
+%description -n   pki-tps-tomcat
+The Token Processing System (TPS) is an optional PKI subsystem that acts
+as a Registration Authority (RA) for authenticating and processing
+enrollment requests, PIN reset requests, and formatting requests from
+the Enterprise Security Client (ESC).
+
+TPS is designed to communicate with tokens that conform to
+Global Platform's Open Platform Specification.
+
+TPS communicates over SSL with various PKI backend subsystems (including
+the Certificate Authority (CA), the Data Recovery Manager (DRM), and the
+Token Key Service (TKS)) to fulfill the user's requests.
+
+TPS also interacts with the token database, an LDAP server that stores
+information about individual tokens.
+
+%{overview}
+
+
 %package -n       pki-javadoc
 Summary:          Certificate System - PKI Framework Javadocs
 Group:            Documentation
@@ -575,11 +609,17 @@ echo "D /var/lock/pki 0755 root root -"     >  %{buildroot}%{_sysconfdir}/tmpfil
 echo "D /var/lock/pki/tks 0755 root root -" >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tks.conf
 echo "D /var/run/pki 0755 root root -"      >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tks.conf
 echo "D /var/run/pki/tks 0755 root root -"  >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tks.conf
+# generate 'pki-tps.conf' under the 'tmpfiles.d' directory
+echo "D /var/lock/pki 0755 root root -"     >  %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
+echo "D /var/lock/pki/tps 0755 root root -" >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
+echo "D /var/run/pki 0755 root root -"      >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
+echo "D /var/run/pki/tps 0755 root root -"  >> %{buildroot}%{_sysconfdir}/tmpfiles.d/pki-tps.conf
 
 %{__rm} %{buildroot}%{_initrddir}/pki-cad
 %{__rm} %{buildroot}%{_initrddir}/pki-krad
 %{__rm} %{buildroot}%{_initrddir}/pki-ocspd
 %{__rm} %{buildroot}%{_initrddir}/pki-tksd
+%{__rm} %{buildroot}%{_initrddir}/pki-tpsd
 
 %{__rm} -rf %{buildroot}%{_datadir}/pki/server/lib
 
@@ -1089,6 +1129,27 @@ fi
 %config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tks.conf
 
 
+%files -n pki-tps-tomcat
+%defattr(-,root,root,-)
+%doc base/tps/LICENSE
+%dir %{_sysconfdir}/systemd/system/pki-tpsd.target.wants
+%{_unitdir}/pki-tpsd@.service
+%{_unitdir}/pki-tpsd.target
+%{_javadir}/pki/pki-tps.jar
+%dir %{_datadir}/pki/tps
+%{_datadir}/pki/tps/conf/
+%{_datadir}/pki/tps/setup/
+%{_datadir}/pki/tps/webapps/
+%dir %{_localstatedir}/lock/pki/tps
+%dir %{_localstatedir}/run/pki/tps
+# Details:
+#
+#     * https://fedoraproject.org/wiki/Features/var-run-tmpfs
+#     * https://fedoraproject.org/wiki/Tmpfiles.d_packaging_draft
+#
+%config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tps.conf
+
+
 %if %{?_without_javadoc:0}%{!?_without_javadoc:1}
 %files -n pki-javadoc
 %defattr(-,root,root,-)
@@ -1097,6 +1158,9 @@ fi
 
 
 %changelog
+* Wed Aug 14 2013 Endi S. Dewata <edewata@redhat.com> 10.1.0-0.10
+- Moved Tomcat-based TPS into pki-core.
+
 * Fri Aug 14 2013 Abhishek Koneru <akoneru@redhat.com> 10.1.0.0.9
 - Listed new packages required during build, due to issues reported
   by pylint.
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index 4f26ebbc48505323be697e34915ab287abe89b05..1a4fff6ff38b6ab3e846ca3013adb7faf9923a7e 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -1,6 +1,6 @@
 Name:             pki-tps
 Version:          10.1.0
-Release:          0.4%{?dist}
+Release:          0.5%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -220,7 +220,6 @@ fi
 %{_bindir}/tpsclient
 %{_libdir}/httpd/modules/*
 %{_libdir}/tps/
-%{_javadir}/pki/pki-tps.jar
 %dir %{_datadir}/pki/tps
 %{_datadir}/pki/tps/applets/
 %{_datadir}/pki/tps/cgi-bin/
@@ -230,7 +229,6 @@ fi
 %{_datadir}/pki/tps/samples/
 %{_datadir}/pki/tps/scripts/
 %{_datadir}/pki/tps/setup/
-%{_datadir}/pki/tps/webapps/
 %dir %{_localstatedir}/lock/pki/tps
 %dir %{_localstatedir}/run/pki/tps
 # Details:
@@ -242,6 +240,9 @@ fi
 
 
 %changelog
+* Wed Aug 14 2013 Endi S. Dewata <edewata@redhat.com> 10.1.0-0.5
+- Moved Tomcat-based TPS into pki-core.
+
 * Thu Jul 11 2013 Ade Lee <alee@redhat.com> 10.1.0-0.4
 - Add systemd build requirement to fix build failures in f19
 
-- 
1.8.1.4

